-- -------------------------------------------------------------------------- --
-- SpellTracker By Xulos ( EU ALLIANCE YSONDRE )                                               --
-- -------------------------------------------------------------------------- --

UIPanelWindows["SpellTrackerFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };

SpellTracker = {};
SpellTracker.Version = GetAddOnMetadata("SpellTracker", "Version");
SpellTracker.BARS = {}; -- stock les abbres qui sont cr au dbut et sont dans le cache
SpellTracker.ScrollValue = 0; -- valeur de la scrolbar virtuelle
SpellTracker.CountBarToDisplay = 0;
SpellTracker.CountBarDisplayed = 0;

function SpellTrackerFrame_Init(self)
	SpellTrackerDB = SpellTrackerDB or {};
	
	SpellTrackerDB.SPELLS = SpellTrackerDB.SPELLS or {}; -- stock les infos a afficher
	
	SpellTrackerDB.Params = SpellTrackerDB.Params or {};
	SpellTrackerDB.Params.SpellBarHeight = SpellTrackerDB.Params.SpellBarHeight or 20;
	SpellTrackerDB.Params.FrameWidth = SpellTrackerDB.Params.FrameWidth or 600;
	SpellTrackerDB.Params.FrameHeight = SpellTrackerDB.Params.FrameHeight or 600;
	-- par default => SpellTrackerDB.Params.DefaultCountSpellsToTrack = 50; -- pilote le nombre de barres qui vont tre cres  l'avance
	-- un raid sur orgri ca fait 200 barres
	SpellTrackerDB.Params.DefaultCountSpellsToTrack = 200; -- pilote le nombre de barres qui vont tre cres  l'avance
	
	SpellTrackerDB.SPELLSTOTTRACK = SpellTrackerDB.SPELLSTOTTRACK or {}; -- stock les sort  traquer
	
	SpellTrackerDB.CurrentPlayerTracked = SpellTrackerDB.CurrentPlayerTracked or {};
	SpellTrackerDB.CurrentPlayerTracked.GUID = SpellTrackerDB.CurrentPlayerTracked.GUID or UnitGUID("player");
	SpellTrackerDB.CurrentPlayerTracked.Name = SpellTrackerDB.CurrentPlayerTracked.Name or UnitName("player");
	SpellTrackerDB.CurrentPlayerTracked.lvl = SpellTrackerDB.CurrentPlayerTracked.lvl or UnitLevel("player");
	SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked or true;
	SpellTrackerDB.MsgToolTip = SpellTrackerDB.MsgToolTip or "Track Source";
	
	SpellTrackerButton_UpdateTitle();
	
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame:SetWidth(SpellTrackerDB.Params.FrameWidth);
		SpellTrackerFrame:SetHeight(SpellTrackerDB.Params.FrameHeight);
	end
	
end
function SpellTrackerMinimapButton_OnClick(self)
    if (SpellTrackerFrame) then
        if(SpellTrackerFrame:IsVisible() ) then
            SpellTrackerFrame:Hide();
		else
            SpellTrackerFrame:Show();
			SpellTracker:UpdateFrame();
		end
    end
end
function hideSpellTrackerFrameButton_OnClick(self) -- Bouton pour fermer la mainFrame
	if (SpellTrackerFrame) then
        SpellTrackerFrame:Hide();
    end
end
function resetSpellTrackerButton_OnClick(self) -- Bouton pour reset les sorts traqus
	SpellTrackerDB.SPELLS = {};
	SpellTrackerButton_UpdateTitle();
	SpellTracker:UpdateFrame();
end
function otherTargetSpellTrackerButton_OnClick(self)
	if ( UnitGUID("target") ) then
		SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("target");
		SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("target");
		SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
	else
		SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("player");
		SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("player");
		SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
	end
	resetSpellTrackerButton_OnClick(self);
end
function AttackORAttackedSpellTrackerButton_OnClick(self)
	SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = not SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked;
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		SpellTrackerDB.MsgToolTip = "Track Source";
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then -- peut valoir nil on sait jamais
		SpellTrackerDB.MsgToolTip = "Track Dest";
	end
	resetSpellTrackerButton_OnClick(self);
end
function SpellTrackerButton_UpdateTitle()
	local vers = SpellTracker.Version;
	local pName = SpellTrackerDB.CurrentPlayerTracked.Name;
	local srcORdst = "";
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		srcORdst = "SRC";
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		srcORdst = "DST";
	end
	SpellTrackerFrameMainMenuTitleTitleText:SetText("SpellTracker r"..vers.." -- Player Tracked : "..pName.." by "..srcORdst);
end
function SpellTrackerButton_ShowTooltip(self, textToShow)
	if ( textToShow ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(textToShow);
	elseif ( SpellTrackerDB.MsgToolTip ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(SpellTrackerDB.MsgToolTip);
	end
end
function SpellTrackerButton_HideTooltip(self)
	 GameTooltip:Hide();
end
function SpellTrackerBar_OnEnter(self) -- affiche des infos sup sur les sort traqus
	if ( self.VAR.Used ) then 
		GameTooltip:SetOwner(self);
		if ( self.VAR.SpellIndexer ) then
			local SpellStruct = SpellTrackerDB.SPELLS[self.VAR.SpellIndexer];
			if ( SpellStruct ) then
				GameTooltip:SetText(SpellStruct.SpellName);
				GameTooltip:AddDoubleLine("Target Type :",SpellStruct.TargetType);
				
				local StatBarColor = SpellTracker.StatusBarColors;
				
				-- self.SpellHitType vaut "Heal" ou "Damage"
				GameTooltip:AddLine("----- "..SpellStruct.SpellHitType.." : -----");
				GameTooltip:AddDoubleLine(StatBarColor.SpellHitAmount..SpellStruct.SpellHitType.." Hit Amount :",StatBarColor.SpellHitAmount..SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellHitAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAmount..SpellStruct.SpellHitType.." Crit Amount :",StatBarColor.SpellCritAmount..SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellCritAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndOverAmount..SpellStruct.SpellHitType.." Over & Crit Amount :",StatBarColor.SpellCritAndOverAmount..SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellCritAndOverAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAmount..SpellStruct.SpellHitType.." Over Amount :",StatBarColor.SpellOverAmount..SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellOverAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAndAbsorbAmount..SpellStruct.SpellHitType.." Over & Absorb Amount :",StatBarColor.SpellOverAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellOverAndAbsorbAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndAbsorbAmount..SpellStruct.SpellHitType.." Crit & Absorb Amount :",StatBarColor.SpellCritAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellCritAndAbsorbAmount));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount..SpellStruct.SpellHitType.." Absorb Amount :",StatBarColor.SpellAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellAbsorbAmount));
				GameTooltip:AddLine("----- "..SpellStruct.SpellHitType.." Total Produced : -----");
				GameTooltip:AddDoubleLine("Amount :",SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellAmountTotal));
				
				GameTooltip:AddLine("----- Count "..SpellStruct.SpellHitType.." Ticks : -----");
				GameTooltip:AddDoubleLine("Count Ticks ", SpellStruct.CountTicks);
				GameTooltip:AddDoubleLine(StatBarColor.SpellHitAmount.." Count Hit ", StatBarColor.SpellHitAmount..tostring(SpellStruct.CountSpellHit));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAmount.." Count Over ", StatBarColor.SpellOverAmount..tostring(SpellStruct.CountSpellOver));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAmount.." Count Crits ", StatBarColor.SpellCritAmount..tostring(SpellStruct.CountSpellCrit));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndOverAmount.." Count Crit & Over ", StatBarColor.SpellCritAndOverAmount..tostring(SpellStruct.CountSpellCritAndOver));
				GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndAbsorbAmount.." Count Crit & Absorb ", StatBarColor.SpellCritAndAbsorbAmount..tostring(SpellStruct.CountSpellCritAndAbsorb));
				GameTooltip:AddDoubleLine(StatBarColor.SpellOverAndAbsorbAmount.." Count Over & Absorb ", StatBarColor.SpellOverAndAbsorbAmount..tostring(SpellStruct.CountSpellOverAndAbsorb));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Missed ", StatBarColor.SpellAbsorbAmount..tostring(SpellStruct.CountSpellMissed));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Immune ", StatBarColor.SpellAbsorbAmount..tostring(SpellStruct.CountSpellImmune));
				GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Absorb ", StatBarColor.SpellAbsorbAmount..tostring(SpellStruct.CountSpellAbsorb));
				
				GameTooltip:Show();
			end
		end
	end
end
function SpellTrackerBar_FormatAmountValueToString(val)
	if (string.len(tostring(val)) > 4 ) then
		return string.format("%.0f", val/1000).."K";
	elseif (string.len(tostring(val)) > 7 ) then
		return string.format("%.0f", val/1000000).."m";
	elseif (string.len(tostring(val)) > 10 ) then
		return string.format("%.0f", val/1000000).."M";
	else
		return string.format("%.0f", val);
	end
end
function SpellTrackerBar_GetColorCodeFromStatusBarColor(StatusBar)
	local codeWow = nil;
	if ( StatusBar ) then
		local r,g,b,a = StatusBar:GetStatusBarColor();
		if ( r and g and b ) then
			codeWow = SpellTrackerBar_GetColorCodeFromRGB(r, g, b);
		end
	end
	return codeWow; 
end
function SpellTrackerBar_GetColorCodeFromRGB(red, green, blue)
	local codeWow = nil;
	if ( red and green and blue ) then
		local redColor = string.format("%0.2X", math.ceil(string.format("%.2f", red)*255));
		local greenColor = string.format("%0.2X", math.ceil(string.format("%.2f", green)*255));
		local blueColor = string.format("%0.2X", math.ceil(string.format("%.2f", blue)*255));
		codeWow = "|cFF"..tostring(redColor)..tostring(greenColor)..tostring(blueColor);
	end
	return codeWow; 
end
function SpellTrackerBar_OnLeave(self)
    GameTooltip:Hide();
end
function SpellTrackerMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("SpellTracker "..SpellTracker.Version);
end
function SpellTrackerMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function SpellTrackerResizeFrame_OnEnter(self) -- widget de redimentionnement -- survol IN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(false);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(1);
	end
end
function SpellTrackerResizeFrame_OnLeave(self) -- widget de redimentionnement -- survol OUT
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(true);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(0);
	end
end
function SpellTrackerResizeFrame_OnMouseDown(self) -- widget de redimentionnement -- CLICK DOWN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame.isMovingOrSizing = false;
		SpellTrackerFrame:SetMinResize(80, 110);
		SpellTrackerFrame:SetMaxResize(800, 800);
		SpellTrackerFrame:StartSizing();
	end
end
function SpellTrackerResizeFrame_OnMouseUp(self) -- widget de redimentionnement -- CLICK UP
	if ( UnitAffectingCombat("player") == nil ) then
		-- on reajuste la valuer y a un mulitple de Hbarre + offsety
		local barHeight = SpellTrackerDB.Params.SpellBarHeight + 2; -- 2 == offset
		local newSpellTrackerFrameScrollLayoutHeight = math.ceil(SpellTrackerFrameScrollLayout:GetHeight() / barHeight)*barHeight;
		local newSpellTrackerFrameHeight = (SpellTrackerFrame:GetHeight() - SpellTrackerFrameScrollLayout:GetHeight()) + newSpellTrackerFrameScrollLayoutHeight;
		SpellTrackerFrame:SetHeight(newSpellTrackerFrameHeight);
		SpellTrackerDB.Params.FrameHeight = newSpellTrackerFrameHeight;
		
		SpellTrackerFrame:StopMovingOrSizing();
		SpellTrackerFrame:ClearAllPoints();
		SpellTrackerFrame.isMovingOrSizing = nil;
		SpellTrackerDB.Params.FrameWidth = SpellTrackerFrame:GetWidth();
		
		SpellTracker:InitFrame(); -- on a redimentionn donc on reinit le layout
	end
end
function SpellTrackerFrameScrollLayout_OnLoad(self) -- chargement du container du grid
	self:RegisterForDrag("LeftButton");
	self:SetScrollChild(SpellTrackerFrameScrollLayoutContainer);
end
function SpellTrackerFrameScrollLayoutVirtualScrollBar_OnMouseWheel (self, delta, stepSize) -- se produit quand la molette de la sourie roule
	if ( delta ) then
		local stepHeight = SpellTrackerDB.Params.SpellBarHeight + 2;-- le step vaut la hauteur d'une barre + 2 == offsety
		stepSize = 1;--SpellTrackerDB.Params.SpellBarHeight + 2; -- le step vaut la hauteur d'une barre + 2 == offsety
		local minVal, maxVal = 0, SpellTracker.CountBarToDisplay-SpellTracker.CountBarDisplayed;
		if ( maxVal < 0 ) then maxVal = 0; end
		
		if ( delta == 1 ) then
			SpellTracker.ScrollValue = max(minVal, SpellTracker.ScrollValue - stepSize);
		elseif ( delta == -1 ) then
			SpellTracker.ScrollValue = min(maxVal, SpellTracker.ScrollValue + stepSize);
		end
		
		SpellTrackerFrameScrollLayout:SetVerticalScroll(SpellTracker.ScrollValue*stepHeight); -- on change la valeur du scroll
	end
end	
function SpellTrackerFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_REGEN_DISABLED"); -- Get Aggro
    self:RegisterEvent("PLAYER_REGEN_ENABLED");	-- Leave Aggro
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED"); -- recuper les event de combat 
end
function SpellTrackerFrame_OnEvent(self, event, ...)
	if ( event == "VARIABLES_LOADED" ) then
		SpellTrackerFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == nil ) then
			SpellTracker:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTracker.Version.." LOADED");
			SpellTracker:UpdateFrame();
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTracker.Version.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(self, ...);
	end
end
-- kernel --
function SpellTracker:CreateBar(frmName)
    local GuiBar = CreateFrame("Button", frmName, SpellTrackerFrame, "SpellTrackerBarTemplate");
        
	GuiBar:RegisterForClicks("AnyUp");
	
	GuiBar.GUI = {};
	GuiBar.GUI.SpellIcon = _G[frmName.."StatusBarSpellHitSpellIcon"];
	GuiBar.GUI.SpellNameLabel = _G[frmName.."StatusBarSpellHitSpellNameLabel"];
	GuiBar.GUI.SpellSpellAmountLabel = _G[frmName.."StatusBarSpellHitSpellAmountLabel"];
	--GuiBar.GUI.SpellOverHitLabel = _G[frmName.."StatusBarSpellHitSpellOverHitLabel"];
	--GuiBar.GUI.SpellCritAmountLabel = _G[frmName.."StatusBarSpellHitSpellCritAmountLabel"];
	--GuiBar.GUI.SpellAbsorbAmountLabel = _G[frmName.."StatusBarSpellHitSpellAbsorbAmountLabel"];
	--GuiBar.GUI.SpellOverHitAndAbsorbAmount = _G[frmName.."StatusBarSpellHitSpellOverHitAndAbsorbAmountLabel"];
	--GuiBar.GUI.SpellCritAndAbsorbAmount = _G[frmName.."StatusBarSpellHitSpellCritAndAbsorbAmountLabel"];
	
	GuiBar.GUI.StatusBarSpellHit = _G[frmName.."StatusBarSpellHit"];
	GuiBar.GUI.StatusBarSpellHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAmountAndHit = _G[frmName.."StatusBarSpellCritAmountAndHit"];
	GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAmount = _G[frmName.."StatusBarSpellCritAmount"];
	GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmount:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHitAndCrit = _G[frmName.."StatusBarSpellOverHitAndCrit"];
	GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHit = _G[frmName.."StatusBarSpellOverHit"];
	GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb = _G[frmName.."StatusBarSpellOverHitAndAbsorb"];
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAndAbsorb = _G[frmName.."StatusBarSpellCritAndAbsorb"];
	GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellAbsorbAmount = _G[frmName.."StatusBarSpellAbsorbAmount"];
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetMinMaxValues(0, 100);
	
	if ( SpellTracker.StatusBarColors == nil ) then -- pour le tooltip de la barre
		SpellTracker.StatusBarColors = {};
		SpellTracker.StatusBarColors.SpellHitAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellHit)
		SpellTracker.StatusBarColors.SpellCritAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellCritAmount)
		SpellTracker.StatusBarColors.SpellCritAndOverAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHitAndCrit)
		SpellTracker.StatusBarColors.SpellOverAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHit)
		SpellTracker.StatusBarColors.SpellOverAndAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHitAndAbsorb)
		SpellTracker.StatusBarColors.SpellCritAndAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellCritAndAbsorb)
		SpellTracker.StatusBarColors.SpellAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellAbsorbAmount)
	end
    GuiBar.VAR = {};
	GuiBar.VAR.SpellIndexer = nil;
	GuiBar.VAR.SpellTracked = false; -- si le spell est demand a traquer
	GuiBar.VAR.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
	
	GuiBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
    GuiBar:SetBackdropBorderColor(0, 0, 0, 0);
	
	return GuiBar;
end
function SpellTracker:ResetBar(GuiBar)
	if ( GuiBar ) then
		GuiBar.GUI.SpellIcon:SetTexture(1,1,1,0); -- on la rend transparante => texture:SetTexture(r, g, b[, a]) avec a = 0
		GuiBar.GUI.SpellNameLabel:SetText("");
		GuiBar.GUI.SpellSpellAmountLabel:SetText("");
		
		GuiBar.GUI.StatusBarSpellHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(0);
		GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
		
		GuiBar.VAR.Used = false;
	end
end
function SpellTracker:InitFrame()
	SpellTracker.CountBarDisplayed = math.ceil(SpellTrackerFrameScrollLayout:GetHeight() / (SpellTrackerDB.Params.SpellBarHeight + 2))-1;
	
	if ( #SpellTracker.BARS == 0 ) then
		local idx = 1;
		local countBarToCreate = SpellTrackerDB.Params.DefaultCountSpellsToTrack;
		for k=0,countBarToCreate do 
			local frmName = "SpellTrackerBar"..tostring(idx);
			local Bar = SpellTracker:CreateBar(frmName);
			--Bar:Hide();
			SpellTracker.BARS[idx] = Bar;
			idx = idx + 1;
		end
	end
	
	local offsetY = -2;
    local mFrameContainer = SpellTrackerFrameScrollLayoutContainer;
	
	local ncolMax, nrowMax, itW, itH = 0, 0, 0, 0;
	local nrowMax = math.ceil(#SpellTracker.BARS);
	
	mFrameContainer:SetWidth(SpellTrackerFrame:GetWidth());
	
	local itW = mFrameContainer:GetWidth();
    local itH = SpellTrackerDB.Params.SpellBarHeight;
	
	local heightMax = nrowMax * itH + offsetY * nrowMax * -1;
	
	mFrameContainer:SetHeight(heightMax);
	
    local lastGuiBar = nil;
	for idx, guiBar in pairs(SpellTracker.BARS) do
		if ( guiBar ) then
			guiBar:SetParent(mFrameContainer);
			if ( lastGuiBar == nil ) then
				guiBar:SetPoint("TOPLEFT", mFrameContainer, "TOPLEFT", 0, 0);
			else
				guiBar:SetPoint("TOPLEFT", lastGuiBar, "BOTTOMLEFT", 0, offsetY);
			end
			guiBar:SetWidth(itW);
			guiBar:SetHeight(itH);
			lastGuiBar = guiBar;
		end
    end
end
function SpellTracker:UpdateFrame()
	local SpellListToSort = {};
	for spellIndexer, spellStruct in pairs(SpellTrackerDB.SPELLS) do
        if ( spellIndexer and spellStruct ) then 
			tinsert(SpellListToSort, spellStruct);
        end
    end
	
	sort(SpellListToSort, 
		function(x,y)
			if ( x and y ) then
				if  ( x.SpellTracked and y.SpellTracked ) then
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				elseif ( x.SpellTracked ) then 
					return true; 
				elseif ( y.SpellTracked ) then 
					return false;
				else -- not ( x.SpellTracked and y.SpellTracked ) 
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				end	
			end
		end);
	
	for i, bar in pairs(SpellTracker.BARS) do
		if ( bar ) then
			if ( bar.VAR.Used ) then -- la barre est utlise;
				SpellTracker:ResetBar(bar); -- on la reset, car la cahcher va porvoquer une erreur en combat
			end
		end
	end
	
	local StatBarColor = SpellTracker.StatusBarColors;
				
	local nBarUsed = 0;
	local idx = 1;
    for spellIndexer, spellStruct in pairs(SpellListToSort) do
		if ( spellIndexer ) then
            local GuiBar = SpellTracker.BARS[idx];
			if ( GuiBar ) then
				nBarUsed = nBarUsed + 1;
                GuiBar.GUI.SpellIcon:SetTexture(spellStruct.SpellIconTex); -- Spell Icon
				GuiBar.VAR.SpellIndexer = spellStruct.SpellIndexer;
				
				local HitType  = "";
				if ( spellStruct.SpellHitType == "HEAL" ) then HitType = "HEAL";
				else HitType = "DMG"; end
				GuiBar.GUI.SpellNameLabel:SetText(tostring(nBarUsed).." "..tostring(HitType).." - "..tostring(spellStruct.SpellName).." x"..tostring(spellStruct.CountTicks).." - "..tostring(spellStruct.TargetType)); -- Spell Name
		
				local AmountString = 
				StatBarColor.SpellHitAmount..SpellTrackerBar_FormatAmountValueToString(spellStruct.SpellHitAmount).."/"..
				StatBarColor.SpellCritAmount..SpellTrackerBar_FormatAmountValueToString(spellStruct.SpellCritAmount).."/"..
				StatBarColor.SpellCritAndOverAmount..SpellTrackerBar_FormatAmountValueToString(spellStruct.SpellCritAndOverAmount).."/"..
				StatBarColor.SpellOverAmount..SpellTrackerBar_FormatAmountValueToString(spellStruct.SpellOverAmount).."/"..
				StatBarColor.SpellOverAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(spellStruct.SpellOverAndAbsorbAmount).."/"..
				StatBarColor.SpellCritAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(spellStruct.SpellCritAndAbsorbAmount).."/"..
				StatBarColor.SpellAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(spellStruct.SpellAbsorbAmount);
				
				GuiBar.GUI.SpellSpellAmountLabel:SetText(AmountString);
				
				if ( spellStruct.SpellAmountTotal > 0 ) then
					local HitAmount = spellStruct.SpellHitAmount*100/spellStruct.SpellAmountTotal;
					--local HitAndCritAmount = spellStruct.SpellHitAndCritAmount*100/spellStruct.SpellAmountTotal;
					local CritAmount = spellStruct.SpellCritAmount*100/spellStruct.SpellAmountTotal;
					local OverHitAndCritAmount = spellStruct.SpellCritAndOverAmount*100/spellStruct.SpellAmountTotal;
					local OverHitAmount = spellStruct.SpellOverAmount*100/spellStruct.SpellAmountTotal;
					local OverHitAmountAndAbsorb = spellStruct.SpellOverAndAbsorbAmount*100/spellStruct.SpellAmountTotal;
					local CritAmountAndAbsorb = spellStruct.SpellCritAndAbsorbAmount*100/spellStruct.SpellAmountTotal;
					
					GuiBar.GUI.StatusBarSpellHit:SetValue(HitAmount);
					GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
					GuiBar.GUI.StatusBarSpellCritAmount:SetValue(CritAmount+HitAmount);
					GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(OverHitAndCritAmount+CritAmount+HitAmount);
					GuiBar.GUI.StatusBarSpellOverHit:SetValue(OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
					GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(OverHitAmountAndAbsorb+OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
					GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(CritAmountAndAbsorb+OverHitAmountAndAbsorb+OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
					GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(100);
				end
				
				GuiBar.VAR.Used = true;
			end
			idx = idx + 1;
		end
	end
	SpellTracker.CountBarToDisplay = nBarUsed-1;
	
end
function SpellTracker:WhatIsThisGuid(GUIDNumber)
	if ( GUIDNumber ~= nil and GUIDNumber ~= "" ) then
		local maskedB = tonumber(GUIDNumber:sub(5,5), 16) % 8; 
		local knownTypes = {[0]="player", [1]="object", [3]="mob", [4]="pet", [5]="vehicle"};
		local result = knownTypes[maskedB] or "Unknow";
		return result; 
    end
    return "Unknow";
end
function SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(_,DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local TargetType, GUID = nil;
		
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		GUID = GUIDSRC;
		TargetType = SpellTracker:WhatIsThisGuid(GUIDDST);
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		GUID = GUIDDST;
		TargetType = SpellTracker:WhatIsThisGuid(GUIDSRC);
	end
        
	if ( GUID == SpellTrackerDB.CurrentPlayerTracked.GUID ) then
		local struct = SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...);
		if ( struct ) then
			SpellTracker:UpdateSpell(TargetType, struct);
		end
    end
end
function SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local Struct = nil;
	if ( EVENTTYPE == "SPELL_DAMAGE" ) then -- domage de sort
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL,	Struct.RESISTED,	Struct.BLOCKED,	
		Struct.ABSORBED,	Struct.CRITICAL,	Struct.GLANCING,	Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_DAMAGE" ) then -- dommage de sort en tick genre dot fievre de givre
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL,	Struct.RESISTED,	Struct.BLOCKED,	
		Struct.ABSORBED,	Struct.CRITICAL,	Struct.GLANCING,	Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE SPELL TICK";
	elseif ( EVENTTYPE == "SWING_DAMAGE" ) then -- coup blanc
		Struct = {};
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL,	Struct.RESISTED,	Struct.BLOCKED,	
		Struct.ABSORBED,	Struct.CRITICAL,	Struct.GLANCING,	Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.SPELLNAME = "COUP BLANC";
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE COUP BLANC";
	elseif ( EVENTTYPE == "SPELL_HEAL" ) then -- sort de soins
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERHEALING,
		Struct.ABSORBED,	Struct.CRITICAL = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "HEAL";
		Struct.TYPE = "HEAL SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_HEAL" ) then -- tick de sort de soins
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERHEALING,
		Struct.ABSORBED,	Struct.CRITICAL = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "HEAL";
		Struct.TYPE = "HEAL SPELL TICK";
	elseif ( EVENTTYPE == "SPELL_MISSED" ) then -- Sort Manqu ou partiellement manqu
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_MISSED" ) then -- Tick de Sort Manqu ou partiellement manqu
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED SPELL TICK";
	elseif ( EVENTTYPE == "SWING_MISSED" ) then -- coup blanc maqnu
		Struct = {};
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.SPELLNAME = "COUP BLANC";
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED COUP BLANC";
	end
	return Struct;
end
function SpellTracker:UpdateSpell(TargetType, CombatLogStruct) -- TargetType = player or MOB / 
	-- voir http://www.wowwiki.com/API_COMBAT_LOG_EVENT
	local SpellIndexer, SpellStruct;
	
	-- Init or not
	SpellIndexer = tostring(CombatLogStruct.HITTYPE).."-"..tostring(CombatLogStruct.SPELLNAME).."-"..TargetType; -- parce que sur certains perso le meme sort peux faire du heal et du dgat
	SpellStruct = SpellTrackerDB.SPELLS[SpellIndexer] or {};
	
	SpellStruct.SpellIndexer = SpellIndexer;
	
	SpellStruct.SpellHitAmount = SpellStruct.SpellHitAmount or 0; -- init ot not
	SpellStruct.SpellHitAndCritAmount = SpellStruct.SpellHitAndCritAmount or 0; -- init ot not
	SpellStruct.SpellCritAmount = SpellStruct.SpellCritAmount or 0; -- init ot not
	SpellStruct.SpellCritAndOverAmount = SpellStruct.SpellCritAndOverAmount or 0; -- init ot not
	SpellStruct.SpellOverAmount = SpellStruct.SpellOverAmount or 0; -- init ot not
	SpellStruct.SpellOverAndAbsorbAmount = SpellStruct.SpellOverAndAbsorbAmount or 0; -- init ot not
	SpellStruct.SpellCritAndAbsorbAmount = SpellStruct.SpellCritAndAbsorbAmount or 0; -- init ot not
	SpellStruct.SpellAbsorbAmount = SpellStruct.SpellAbsorbAmount or 0; -- init ot not
	
	SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal or 0; -- init ot not
	
	SpellStruct.BestSpellAbsorbAmount = SpellStruct.BestSpellAbsorbAmount or 0; -- init ot not
	SpellStruct.BestSpellCritAmount = SpellStruct.BestSpellCritAmount or 0; -- init ot not
	SpellStruct.BestSpellHitAmount = SpellStruct.BestSpellHitAmount or 0; -- init ot not
	SpellStruct.BestSpellOver = SpellStruct.BestSpellOver or 0; -- init ot not

	SpellStruct.CountTicks = SpellStruct.CountTicks or 0;
	SpellStruct.CountSpellHit = SpellStruct.CountSpellHit or 0; -- Nombre de Hit
	SpellStruct.CountSpellMissed = SpellStruct.CountSpellMissed or 0; -- Nombre de Hit
	SpellStruct.CountSpellImmune = SpellStruct.CountSpellImmune or 0; -- Nombre de Hit
	SpellStruct.CountSpellAbsorb = SpellStruct.CountSpellAbsorb or 0; -- Nombre de Hit
	SpellStruct.CountSpellOver = SpellStruct.CountSpellOver or 0; -- Nombre de Hit
	SpellStruct.CountSpellCrit = SpellStruct.CountSpellCrit or 0; -- Nombre de Hit
	SpellStruct.CountSpellCritAndOver = SpellStruct.CountSpellCritAndOver or 0; -- Nombre de Hit
	SpellStruct.CountSpellCritAndAbsorb = SpellStruct.CountSpellCritAndAbsorb or 0; -- Nombre de Hit
	SpellStruct.CountSpellOverAndAbsorb = SpellStruct.CountSpellOverAndAbsorb or 0; -- Nombre de Hit
	
	-- Affect
	SpellStruct.SpellIconTex = ""; -- chemin de la texture du sort
	SpellStruct.SpellId = SpellStruct.SpellId or CombatLogStruct.SPELLID; -- id du sort
	SpellStruct.SpellName = CombatLogStruct.SPELLNAME; -- nom du sort	
	SpellStruct.SpellHitType = CombatLogStruct.HITTYPE; -- type du sort
	SpellStruct.TargetType = TargetType;
	SpellStruct.SpellIconTex = GetSpellTexture(CombatLogStruct.SPELLNAME);
	
	SpellStruct.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
	
	--print("CombatLogStruct.HITTYPE=",CombatLogStruct.HITTYPE);
	--print("CombatLogStruct.AMOUNT=",CombatLogStruct.AMOUNT);
	--print("CombatLogStruct.OVERKILL=",CombatLogStruct.OVERKILL);
	--print("CombatLogStruct.ABSORBED=",CombatLogStruct.ABSORBED);
	--print("CombatLogStruct.OVERHEALING=",CombatLogStruct.OVERHEALING);
	
	CombatLogStruct.ABSORBED = CombatLogStruct.ABSORBED or 0;
	CombatLogStruct.OVERKILL = CombatLogStruct.OVERKILL or 0;
	CombatLogStruct.OVERHEALING = CombatLogStruct.OVERHEALING or 0;
	CombatLogStruct.CRITICAL = CombatLogStruct.CRITICAL or 0;
	if ( CombatLogStruct.OVERKILL < 0 ) then
		CombatLogStruct.OVERKILL = 0;
	end
	
	-- affectation des donnes selon le log de combat
	local SpellAmountTotal = 0;
	local SpellHitAmount = 0;
	local SpellCritAmount = 0;
	local SpellCritAndOverAmount = 0;
	local SpellOverAmount = 0;
	local SpellOverAndAbsorbAmount = 0;
	local SpellCritAndAbsorbAmount = 0;
	local SpellAbsorbAmount = 0;
	
	-- AMOUNT = 145000
	-- OVERKILL = 32000
	-- ce qui veut dure sur sur les 145000 seulement 32000 sont en exces
	-- donc AMOUNT vaut en fait AMOUNT - OVERKILL
	if ( CombatLogStruct.HITTYPE == "DAMAGE" ) then -- DAMAGE
		if ( CombatLogStruct.CRITICAL > 0 ) then -- crit
			SpellCritAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERKILL;
			SpellCritAndOverAmount = CombatLogStruct.OVERKILL;
			SpellCritAndAbsorbAmount = CombatLogStruct.ABSORBED;
		else -- normal
			SpellHitAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERKILL;
			SpellOverAmount = CombatLogStruct.OVERKILL;
			SpellAbsorbAmount = CombatLogStruct.ABSORBED;
		end
	elseif ( CombatLogStruct.HITTYPE == "HEAL" ) then -- HEAL
		if ( CombatLogStruct.CRITICAL > 0 ) then -- crit
			SpellCritAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERHEALING;
			SpellCritAndOverAmount = CombatLogStruct.OVERHEALING;
			SpellCritAndAbsorbAmount = CombatLogStruct.ABSORBED;
		else -- normal
			SpellHitAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERHEALING;
			SpellOverAmount = CombatLogStruct.OVERHEALING;
			SpellAbsorbAmount = CombatLogStruct.ABSORBED;
		end
	elseif ( CombatLogStruct.HITTYPE == "MISSED" ) then -- MISSED
		if ( CombatLogStruct.MISSEDTYPE == "ABSORB" ) then
			SpellAbsorbAmount = CombatLogStruct.AMOUNT;
		end
	end
	
	-- Montants
	SpellStruct.SpellHitAmount = SpellStruct.SpellHitAmount + SpellHitAmount;
	SpellStruct.SpellCritAmount = SpellStruct.SpellCritAmount + SpellCritAmount;
	SpellStruct.SpellCritAndOverAmount = SpellStruct.SpellCritAndOverAmount + SpellCritAndOverAmount;
	SpellStruct.SpellOverAmount = SpellStruct.SpellOverAmount + SpellOverAmount;
	SpellStruct.SpellCritAndAbsorbAmount = SpellStruct.SpellCritAndAbsorbAmount + SpellCritAndAbsorbAmount;
	SpellStruct.SpellOverAndAbsorbAmount = SpellStruct.SpellOverAndAbsorbAmount + SpellOverAndAbsorbAmount;
	SpellStruct.SpellAbsorbAmount = SpellStruct.SpellAbsorbAmount + SpellAbsorbAmount;
	
	local CurrentSpellTotalAmount = 
		SpellCritAmount + SpellCritAndOverAmount + SpellCritAndAbsorbAmount + -- crit
		SpellHitAmount + SpellOverAmount + SpellAbsorbAmount; -- hit
		
	SpellStruct.SpellAmountTotal = SpellStruct.SpellAmountTotal + CurrentSpellTotalAmount;
	
	-- Ticks
	if ( SpellHitAmount > 0 ) then SpellStruct.CountSpellHit = SpellStruct.CountSpellHit + 1; end
	if ( SpellCritAmount > 0 ) then SpellStruct.CountSpellCrit = SpellStruct.CountSpellCrit + 1; end
	if ( SpellCritAndOverAmount > 0 ) then SpellStruct.CountSpellCritAndOver = SpellStruct.CountSpellCritAndOver + 1; end
	if ( SpellOverAmount > 0 ) then SpellStruct.CountSpellOver = SpellStruct.CountSpellOver + 1; end
	if ( SpellCritAndAbsorbAmount > 0 ) then SpellStruct.CountSpellCritAndAbsorb = SpellStruct.CountSpellCritAndAbsorb + 1; end
	if ( SpellOverAndAbsorbAmount > 0 ) then SpellStruct.CountSpellOverAndAbsorb = SpellStruct.CountSpellOverAndAbsorb + 1; end
	if ( SpellAbsorbAmount > 0 ) then SpellStruct.CountSpellAbsorb = SpellStruct.CountSpellAbsorb + 1; end
	
	if ( CurrentSpellTotalAmount > 0 ) then
		-- 1 tick de plus
		SpellStruct.CountTicks = SpellStruct.CountTicks + 1;
		-- on stock ou on maj la structure
		SpellTrackerDB.SPELLS[SpellIndexer] = SpellStruct;
		-- On maj la frame
		SpellTracker:UpdateFrame();
	end
end

-- COMBAT_LOG_EVENT_UNFILTERED
--[[
1st Param 	2nd Param 	3rd Param 	4th Param 	5th Param 	6th Param 	7th Param 		8th Param 	9th Param 	10th Param 	11th Param
timestamp 	event 		hideCaster 	sourceGUID 	sourceName 	sourceFlags sourceFlags2 	destGUID 	destName 	destFlags 	destFlags2

prefix 			1st Parameter (12th) 	2nd Paramater (13th) 	3rd Parameter (14th)
SWING
RANGE 			spellId 				spellName 				spellSchool
SPELL 			spellId 				spellName 				spellSchool
SPELL_PERIODIC 	spellId 				spellName 				spellSchool
SPELL_BUILDING 	spellId 				spellName 				spellSchool
ENVIRONMENTAL 	environmentalType

Suffix 				1st Param (15th)	2nd Param (16th)	3rd Param (17th)	4th Param (18th)	5th Param (19th)	6th Param (20th)	7th Param (21th)	8th Param (22th)	9th Param (23th)
_DAMAGE 			amount 				overkill 			school 				resisted 			blocked 			absorbed 			critical (1 or nil) glancing (1 or nil) crushing (1 or nil)
_MISSED 			missType			isOffHand 			amountMissed*
_HEAL 				amount 				overhealing 		absorbed 			critical
_ENERGIZE 			amount 				powerType
_DRAIN 				amount 				powerType 			extraAmount
_LEECH 				amount 				powerType 			extraAmount
_INTERRUPT 			extraSpellID 		extraSpellName 		extraSchool
_DISPEL 			extraSpellID 		extraSpellName 		extraSchool 		auraType
_DISPEL_FAILED 		extraSpellID 		extraSpellName 		extraSchool
_STOLEN 			extraSpellID 		extraSpellName 		extraSchool 		auraType
_EXTRA_ATTACKS 		amount
_AURA_APPLIED 		auraType
_AURA_REMOVED 		auraType
_AURA_APPLIED_DOSE 	auraType 			amount
_AURA_REMOVED_DOSE 	auraType 			amount
_AURA_REFRESH 		auraType
_AURA_BROKEN 		auraType
_AURA_BROKEN_SPELL 	extraSpellID 		extraSpellName 		extraSchool 		auraType
_CAST_START
_CAST_SUCCESS
_CAST_FAILED 		failedType
_INSTAKILL
_DURABILITY_DAMAGE
_DURABILITY_DAMAGE_ALL
_CREATE
_SUMMON
_RESURRECT

Event 					Prefix to use 		Suffix to use
DAMAGE_SHIELD 			SPELL 				_DAMAGE
DAMAGE_SPLIT 			SPELL 				_DAMAGE
DAMAGE_SHIELD_MISSED 	SPELL 				_MISSED

Event 				1st Param 	2nd Param 	3rd Param
ENCHANT_APPLIED 	spellName 	itemID 		itemName
ENCHANT_REMOVED 	spellName 	itemID 		itemName
PARTY_KILL
UNIT_DIED
UNIT_DESTROYED

Event Prefix Description
SPELL_
Spell is the prefix for most effects even if the spell is a DoT or channeled. IE when the spell begins to be cast, SPELL_CAST_START is
fired and not SPELL_PERIODIC_CAST_START. This is the same with _MISS, _FAILED, etc.

SPELL_PERIODIC
Spell_PERIODIC Only the effects that are periodic start with this PREFIX. IE: Successfully casting a DoT only happens once therefor
even though the spell is periodic use the SPELL_ prefix. However, the damage is periodic so it will start with SPELL_PERIODIC_. 90%
of the time you will only care about _DAMAGE or _HEAL.
SPELL_BUILDING SPELL_BUILDING New in WotLK, assumed to be damage that can affect destructable buildings.
ENVIRONMENTAL sourceGUID = "0x0000000000000000", sourceName = nil

Suffixes
Event Prefix Description
_DAMAGE Triggered on damage to health. Nothing Special. (overkill returns a number greater than or equal to zero)

_MISSED
Triggered When Effect isn't applied but mana/energy is used IE: ABSORB BLOCK DEFLECT DODGE EVADE IMMUNE MISS
PARRY REFLECT RESIST

_HEAL Triggered when a unit is healed

_ENERGIZE
Any effect that restores energy/mana. Spell/trinket/item set bonuses can trigger this event. IE: Vampiric Touch, or Mark of
Defiance (Trinket)

_DRAIN Same as _ENERGIZE but this time you are losing energy/mana. Caused by enemies.

_LEECH Same as _DRAIN, but the source unit will simultaneously receive the same kind of energy (specified in extraAmount)

_INTERRUPT Spellcasting being interrupted by an ability such as Kick or Pummel.

_DISPEL A buff or debuff being actively dispelled by a spell like Remove Curse or Dispel Magic.

_DISPEL_FAILED A failed attempt to dispel a buff or debuff, most likely due to immunity.

_AURA_STOLEN A buff being transferred from the destination unit to the source unit (i.e. mages' Spellsteal).

_EXTRA_ATTACKS
Unit gains extra melee attacks due to an ability (like Sword Specialization or Windfury). These attacks usually happen in
brief succession 100-200ms following this event.

_AURA_APPLIED
Triggered When Buffs/Debuffs are Applied. Note: This event doesn't fire if a debuff is applied twice without being removed.
IE: casting Vampiric Embrace twice in a row only triggers this event once. This can make it difficult to track whether a debuff
was successfully reapplied to the target. However, for instant cast spells, SPELL_CAST_SUCCESS can be used.

_AURA_REMOVED Triggered When Buffs/Debuffs expire.

_AURA_APPLIED_DOSE
Triggered by stacking Debuffs if the debuff is already applied to a target. IE: If you cast Mind Flay twice it causes 2 doses of
shadow vunerability, the first time it will trigger, SPELL_AURA_APPLIED (arg10 = shadow vulnerability), and
SPELL_AURA_APPLIED_DOSE (arg10 = shadow vunerability) the second. The last argument reflects the new number of
doses on the unit.

_AURA_REMOVED_DOSE The opposite of _AURA_APPLIED_DOSE, reducing the amount of doses on a buff/debuff on the unit.

_AURA_REFRESH Resets the expiration timer of a buff/debuff on the unit.

_AURA_BROKEN A buff or debuff is being removed by melee damage

_AURA_BROKEN_SPELL A buff or debuff is being removed by spell damage (specified in extraSpell...)

_CAST_START
Triggered when a spell begins casting. Instant Cast and channeled spells don't invoke this event. They trigger

_CAST_SUCCESS, _MISS instead.

_CAST_SUCCESS
Triggered when channeled spells begin or when instant cast spells are cast. This (obviously) isn't triggered when this spell
misses. On a miss SPELL_MISS will be triggered instead. Also, spells that invoke _CAST_START don't trigger this event
when they are done casting. Use _SPELL_MISS or _SPELL_DAMAGE or _SPELL_AURA_APPLIED to see when they were
cast

_CAST_FAILED
If the cast fails before it starts (IE invalid target), then _CAST_START never triggers. However it is possible for a cast to fail
after beginning. (IE you jump, move, hit escape etc.)

_INSTAKILL Immediately kills the destination unit (usually happens when warlocks sacrifice their minions).

_DURABILITY_DAMAGE

_DURABILITY_DAMAGE_ALL

_CREATE Creates an object (as opposed to an NPC who are 'summoned') like a hunter's trap or a mage's portal.

_SUMMON Summmons an NPC such as a pet or totem.

Special Events
Event Description
UNIT_DIED destGUID and destName refer to the unit that died.
PARTY_KILL includes both sourceGUID and destGUID, but only reports for you (not in a party) or your other 4 party members (not raid members)
]]--